// StandardFieldsMessage.h
/*************************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of California, as
* Operator of Los Alamos National Laboratory. MPF is distributed
* subject to a Software License Agreement found in file LICENSE that
* is included with this distribution.
*************************************************************************/

#ifndef StandardFieldsMessageH
#define StandardFieldsMessageH

class Message;
class DLList;

enum timeoutUnitsValue { timeoutUnitsSeconds=0,timeoutUnitsMilliseconds};

class StandardFieldsMessage : public Message
{
public:
    virtual ~StandardFieldsMessage() {}
    virtual int32  toBuffer(char **buffer) const;
    virtual int32  fromBuffer(const char **buffer);
    virtual int32  fromBufferSwitch(const char **buffer);
    virtual void print() const;
    //following are for use by client/server
    //Each may be used as desired
    uint32 timeoutUnits;
    uint32 timeout;
    uint32 cmd;
    int32 status;
    int32 address;
    int32 extra;
protected:
    StandardFieldsMessage(messageType type);
private:
    // Disallow copy constructor, assignment operator 
    StandardFieldsMessage(const StandardFieldsMessage&);
    StandardFieldsMessage& operator=(const StandardFieldsMessage&);
};

inline StandardFieldsMessage:: StandardFieldsMessage(messageType type)
: Message(type), timeout(0), cmd(0), status(0), address(0), extra(0)
{}

#endif /*StandardFieldsMessageH*/
